/**
 * 
 */
package np.org.mpp.frameparser;
import java.io.File;

import np.org.mpp.logger.Logger;

import org.w3c.dom.Document;
import org.w3c.dom.Element;
import org.w3c.dom.NodeList;
import org.w3c.dom.Node;
import org.w3c.dom.Text;

import java.util.HashMap;
import java.util.Hashtable;
import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;

/** Parses the frame
 * @author mpp
 *
 */
public class FrameParser {
	
	public Document doc = null; 
	public Node itemPostPos;
	private KarakaFrame karakaframe;
	private static String nodeName = "postpos";
	private String verbPopn=null; 
	public int totalFrame = 0;
	public static  HashMap<File, FrameParser> fileParserMap;
	public static int accessCount=0;
//	private static FrameParser frameParserInstance;
	/** Creates new instance of DocumentBuilderFactory, builds new Document
	 * and parse the argument file
	 * 
	 * @param file
	 */
	private FrameParser(File file){
		this.parseXmlFile(file);
	}
	private void parseXmlFile(File file ) {
		try {
			DocumentBuilderFactory dbf = DocumentBuilderFactory.newInstance();
			DocumentBuilder db = dbf.newDocumentBuilder();
			this.doc = db.parse(file);
		}catch ( Throwable t) { t.printStackTrace();}
	}
	@SuppressWarnings("null")
	public static FrameParser getFrameParserInstance(File file)throws Exception{
		if(accessCount==0){			
			fileParserMap=new HashMap<File, FrameParser>();
			accessCount++;
		}
		if(file==null){
			throw new Exception(file.getName()+" not found");
		}
		else{
			if(fileParserMap.containsKey(file)){				
				return fileParserMap.get(file);
			}
			else{
				FrameParser fp=new FrameParser(file);
				fileParserMap.put(file, fp);				
				return fp;
			}
		}
	}
//	public static FrameParser getInstance(File file){
//		return 
//	}
	/**Search the post position tag  and identifies its corresponding node
	 * writes itemPostPos 
	 * @param str : The String <B>str</B> to be searched. 
	 * 
	 */
	public void searchPostPosition( String str ) throws MPPCustomizedException{
		this.itemPostPos = null;
		Element rootElement = this.doc.getDocumentElement();
		NodeList itemList = rootElement.getElementsByTagName("item");
		NodeList item = null;
		Node n = null;
		Element e = null;
		Text t = null;
		String s = null;
		boolean flag1=true;
		for( int i = 0; i < itemList.getLength()&&flag1; i++ )	{
			boolean flag2=true;
			item = itemList.item(i).getChildNodes();
			for ( int j=0; j < item.getLength()&&flag2; j++)	{
				n = item.item(j);
				if ( n instanceof Element ){
					e = (Element)n;
					if (e.getNodeName()==nodeName)	{						
						t = (Text)e.getChildNodes().item(0);
						s = t.getNodeValue();
						flag2=false;
						if ( s.equals(str)) {
							this.itemPostPos=n.getParentNode();
							this.verbPopn= str;
							flag1=false;
						} 
					}
				}
			}
		}
		if(this.itemPostPos==null){
			throw new MPPCustomizedException("Could not find post position in frame file " + str);
		}
	}
	/** loads frame into array list
	 * @param null
	 * @return void
	 */
	public void loadFrame () {
		Element el = (Element) itemPostPos.getChildNodes();
		
		NodeList kframeList = el.getElementsByTagName("kframe");
		Hashtable <String,String>frame;
		this.karakaframe = new KarakaFrame(this.verbPopn);
		NodeList frameItem=null;
		Node frameNode = null;
		Element frameElement = null;
		Text frameText = null;
		
		for ( int i=0; i < kframeList.getLength(); i++){
			frameItem = kframeList.item(i).getChildNodes();
			frame=new Hashtable <String, String> ();
			for ( int j=0; j < frameItem.getLength(); j++) {
				frameNode = frameItem.item(j);
				if( frameNode instanceof Element){
					frameElement = (Element)frameNode;
					frameText = (Text)frameElement.getChildNodes().item(0);
					frame.put(frameElement.getNodeName().trim(), frameText.getData().trim());
				}
			}
			this.karakaframe.insertFrame(frame);
		}
	}//end loadFrame
	/**Returns the karakaframe
	 * @return KarakaFrame karakaframe
	 * @param void
	 */
	public KarakaFrame getFrame () {
		return this.karakaframe;
	}

	/**The main method of the FrameParser class.
	 * @param args
	 */
	/**
	public static void main(String[] args) {
		FrameParser fp = new FrameParser ( );
		String s = "cha";
		fp.parseXmlFile(new File (args[0]));
		fp.searchPostPosition(s);
		fp.loadFrame();
		KarakaFrame kf = fp.getFrame();
		String tags[]={"karaka"  , "lextype", "vibakti1", "mandatory","position"};
		int i,j;
		System.out.println("Item:-"+kf.getPostPosn()+" "+"Frames:-"+kf.getSize());
		System.out.println("<------------->");
		for(i=0;i<kf.getSize();i++){
			for(j=0;j<tags.length;j++){
				System.out.println(tags[j] + ": "+kf.get(i, tags[j]));
			}
			System.out.println("<------------>");
		}
		
		fp.searchPostPosition("tdach");
		fp.loadFrame();
		KarakaFrame kft=fp.getFrame();
		
		FrameTransformer ft=new FrameTransformer(kf,kft);
		ft.transform();
		
		kf=ft.getTransformedFrame();
		
		System.out.println("<*****Transformed Frame ******* >");
		for(i=0;i<kf.getSize();i++){
			for(j=0;j<tags.length;j++){
				System.out.println(tags[j] + ": "+kf.get(i, tags[j]));
			}
			System.out.println("<----------------->");
		}
		
	}//end main
	**/
}//end FrameParser
