/**
 * 
 */
package np.org.mpp.frameparser;

/**
 * @author mpp
 *
 */
public class FrameTransformer {
	/**
	 * Root frame that is to be transformed by transformer frame
	 */
	private KarakaFrame rootFrame;
	/**
	 * Transforming frame that will transform root frame
	 */
	private KarakaFrame transformerFrame;
	private static String KARAKA="karaka";
	private static String VIBHAKTI="vibakti";
	
	/**
	 * 
	 * @param f1 frame to be transformed
	 * @param f2 frame that will transform f1
	 */
	public FrameTransformer(KarakaFrame f1, KarakaFrame f2){
		this.rootFrame=f1;
		this.transformerFrame=f2;
		
	}
	/**
	 * transform the root frame with the help of transforming frame
	 */
	public void transform(){
		int j;// root frame index
		int i;//transformer frame index
		
		for(i=0;i<this.transformerFrame.getSize();i++){
			String kModifier=this.transformerFrame.get(i, KARAKA);
			for(j=0;j<this.rootFrame.getSize();j++){
				String kRoot=this.rootFrame.get(j, KARAKA);
				if(kRoot.equals(kModifier)){
					String tVibakti=this.transformerFrame.get(i, VIBHAKTI);
					this.rootFrame.setAttr(i, VIBHAKTI, tVibakti);
				}
			}
		}
	}
	/**
	 * 
	 * @return KarakaFrame transformed
	 */
	public KarakaFrame getTransformedFrame(){
		return this.rootFrame;
	}
}
