package np.org.mpp.parser;
import java.util.ArrayList;
import np.org.mpp.logger.Logger;

public class ChunkParser {
	private String chunkSentence;
	private ArrayList<ChunkCapsule> chunkCapsuleList;
	ChunkParser(String sentence){
		this.chunkSentence=sentence;
		this.chunkCapsuleList=new ArrayList<ChunkCapsule>();
		Logger.log("Sentence is : "+this.chunkSentence);
	}
	public void parseAndLoad()throws Exception{
		String pattern="[{]";
		String chunkTokens[]=this.chunkSentence.split(pattern);
		int length=chunkTokens.length;
		int i=0;
		int j;	
		String wordPosTokens[];
		String wordTokens[];
		String endTokens[];
		WordPosPair wordPosPair;
		ChunkCapsule chunkCapsule;
		for(i=0;i<length;i++){
			wordPosTokens=chunkTokens[i].split("}/");
			if(wordPosTokens.length==2){
				chunkCapsule=new ChunkCapsule(wordPosTokens[1]);
				wordTokens=wordPosTokens[0].split(" ");
				for(j=0;j<wordTokens.length;j++){
					endTokens=wordTokens[j].split("/");
					if(endTokens.length==2){
						wordPosPair=new WordPosPair(endTokens[0],endTokens[1]);
						chunkCapsule.loadWordPosPair(wordPosPair);
					}
				}
				this.chunkCapsuleList.add(chunkCapsule);
			}
		}
	}
	
	public ArrayList<ChunkCapsule> getChunkCapusleList(){
		return this.chunkCapsuleList;
	}
	public void display(){
		for(int i=0;i<this.chunkCapsuleList.size();i++){
			ChunkCapsule cc=this.chunkCapsuleList.get(i);
			for(int j=0;j<cc.getListLength();j++){
				System.out.print(cc.getWord(j)+"/"+cc.getTag(j)+" ");
			}
			System.out.println(" "+cc.getChunkTag());
		}
	}
	
	public static void main(String args[]){
		String sentence="{ram/nn sita/nn le/POP}/NCH {ghar/nn bata/pop}/nch {gaye/vb}/vch";
		ChunkParser cp=new ChunkParser(sentence);
		try{
			cp.parseAndLoad();
		}
		catch(Exception e){
			System.out.println(e.toString());
		}
		System.out.println("\n\n\n***********");
		cp.display();
		String str="le, lai";
		String temp[]=str.split(",");
		for(int i=0;i<temp.length;i++){
		System.out.println(temp[i]+ temp.length);
		}
	}
	
}
