package np.org.mpp.parser;

import java.io.File;
import java.util.Scanner;
import java.util.logging.Logger;

import np.org.mpp.cmdlineparser.CMDLineParser;
import np.org.mpp.configparser.ConfigParsers;

public class ConstraintBasedParser {
	private String sentence;
	private ChunkParser chunkParser;
	private ChunkRelationFinder chunkRelationFinder;
	private String configFilePath;
	ConfigParsers configParser;
	public ConstraintBasedParser(String sentence){
		this.sentence=sentence;
	
	}
	public void setConfigFilePath(String configFilePath){
		this.configFilePath=configFilePath;
		this.configParser=ConfigParsers.configParserFactory(this.configFilePath);
	}
	public void init(){
		this.chunkParser=new ChunkParser(this.sentence);
		try{
			this.chunkParser.parseAndLoad();
			//this.chunkParser.display();
		}
		catch(Exception e){
			System.out.println(e.toString());
			System.exit(0);
		}
		this.chunkRelationFinder=new ChunkRelationFinder(this.chunkParser.getChunkCapusleList());
		this.chunkRelationFinder.setConfigFilePath(this.configFilePath);
		this.chunkRelationFinder.start();
	}
	public void dispalyParse(){
		this.chunkRelationFinder.displayParse();
	}
	public boolean isParsed(){
		return this.chunkRelationFinder.isParsed();
	}
	
	/**
	 * @param args
	 */
	public static void main(String[] args) {
		// TODO Auto-generated method stub
		try{
			CMDLineParser clp=new CMDLineParser(args);
			String [] manOptions = {"-i","-c"};
			String [] optOptions = {"-h"};
			clp.loadOptionsMan(manOptions);
			clp.loadOptionsOpt(optOptions);
			clp.parseAndLoad();
			if(clp.get("-h")!=null){
				System.out.println("<Usage: ");
				System.exit(0);
			}
			Scanner sc=new Scanner(new File(clp.get("-i")),"UTF-8");
			String sentence=sc.nextLine();
			ConstraintBasedParser cbp=new ConstraintBasedParser(sentence);
			if(clp.get("-c")!=null){
				cbp.setConfigFilePath(clp.get("-c"));
				
				cbp.init();
			
				cbp.dispalyParse();
		}
		
			
		}
		catch(Exception e){
			System.out.println(e.toString());
		}

	}

}
