package np.org.mpp.poptokenizer;
import np.org.mpp.cmdlineparser.CMDLineParser;
import np.org.mpp.cmdlineparser.*;
import java.util.*;
import java.io.*;


public class PopTokenizer {
	private Scanner inputSc;
	private Scanner exceptionSc;
	//private Scanner specialCharSc;
	private Scanner inputPopSc;
	private PrintStream outputPs;
	private ArrayList<String> popList;
	private ArrayList<String> exceptionList;
	//private ArrayList<String> specialCharList;
	
	PopTokenizer(String inputFile,String inputPopFile,String exceptionFile, String outputFile){
		try{
			this.inputSc=new Scanner(new File(inputFile),"UTF-8");
			this.exceptionSc=new Scanner(new File(exceptionFile),"UTF-8");
			//this.specialCharSc=new Scanner(new File(specialCharFile),"UTF=8");
			this.outputPs=new PrintStream(new File(outputFile),"UTF-8");
			this.inputPopSc=new Scanner(new File(inputPopFile));
		}
		catch(Exception e){
			System.out.println(e.toString());
			System.exit(0);
		}
		this.popList=new ArrayList<String>();
		this.exceptionList=new ArrayList<String>();
		//this.specialCharList=new ArrayList<String>();
	}
	public void readPop(){
		while(this.inputPopSc.hasNext()){
			String token=this.inputPopSc.nextLine();
			this.popList.add(token);
		}
		this.inputPopSc.close();
		while(this.exceptionSc.hasNext()){
			String token=this.exceptionSc.nextLine();
			this.exceptionList.add(token);
		}
		this.exceptionSc.close();
		
		/*while(this.specialCharSc.hasNext()){
			String token=this.specialCharSc.nextLine();
			System.out.println(token);
			this.specialCharList.add(token);
		}
		this.specialCharSc.close();	*/
	}
	
	public void readAndTokenizePop(){
		while(this.inputSc.hasNext()){
			String token=this.inputSc.nextLine();
			if(token.length()>1){
				token=this.searchSpecialChar(token);
			}
			boolean flag=true;
			for(int i=0;i<this.popList.size()&&flag;i++){
				String pop=this.popList.get(i);
				if(token.endsWith(pop)&& !this.exceptionList.contains(token)){
					int endIndex=token.length()-pop.length();
					String seed=token.substring(0,endIndex);
					this.outputPs.println(seed);
					this.outputPs.println(pop);
					flag=false;
				}				
			}
			if(flag){
				this.outputPs.println(token);
			}
		}
	}
	
	private String searchSpecialChar(String str){
		String token=str;
		char last=str.charAt(str.length()-1);
		char first=str.charAt(0);
		if(first=='\'' || first==','){
			this.outputPs.println(first);
			token=token.substring(1, token.length());
		}
		if(last=='\'' || last==','){
			token=token.substring(0, token.length()-1);
		}
		return token;
	}

	
	
	public static void main(String args[]){
            
            CMDLineParser clp = new CMDLineParser(args);
                String manOpts[]={"-i", "-pop", "-exp", "-o"}; 
                clp.loadOptionsMan(manOpts);
                String optOpts[]={"-h"};
                clp.loadOptionsOpt(optOpts);
                
                clp.parseAndLoad();
                
                
                if ( clp.get("-i")!=null || clp.get("-o")!=null ){
                	PopTokenizer pt=new PopTokenizer(clp.get("-i"),clp.get("-pop"),clp.get("-exp"),clp.get("-o"));
			pt.readPop();
			pt.readAndTokenizePop();   
                }
                else {
                    System.out.print("Usage: \n-i input \n-o output \n-h (help)");
                }	
	}	
}
