package np.org.mpp.wordaligner;
import np.org.mpp.cmdlineparser.*;

import java.util.*;
import java.io.*;
public class WordAligner {
	private Scanner sc;
	private PrintStream ps;
	WordAligner(String input, String output){
		try{
			sc=new Scanner(new File(input),"UTF-8");
			ps=new PrintStream(new File(output),"UTF-8");
		}
		catch(Exception e){
			System.out.println(e);
			System.exit(0);
		}
	}
	public void align(){
		while(sc.hasNext()){
			String token=sc.next();
			ps.println(token);
			if(token.equals("।")){
				ps.println();
			}
		}
	}
	public static void main(String args[]){
                CMDLineParser clp = new CMDLineParser(args);
                String manOpts[]={"-i", "-o"}; 
                clp.loadOptionsMan(manOpts);
                String optOpts[]={"-h"};
                clp.loadOptionsOpt(optOpts);
                
                clp.parseAndLoad();
                
                
                if ( clp.get("-i")!=null || clp.get("-o")!=null ){
                   WordAligner wa=new WordAligner(clp.get("-i"),clp.get("-o"));
                    wa.align();
//                    System.out.println(clp.get("-i"));
                }else {
                    System.out.print("Usage: \n-i input \n-o output \n-h (help)");
                }
                
	}
}
