package np.org.mpp.xmltotnt;
import javax.xml.parsers.*;
import org.w3c.dom.*;
import java.io.*;
import java.io.PrintStream;

public class XMLToTNTConverter {
	XMLToTNTConverter(String FileName,String OutFile){
		this.FileName=FileName;
		this.OutFile=OutFile;
	}
	public void init() throws Exception
	{
		DocumentBuilderFactory factory= DocumentBuilderFactory.newInstance();
		try{
			DocumentBuilder builder = factory.newDocumentBuilder();
			File f=new File(this.FileName);
			
			this.doc=builder.parse(f);
		}
		catch(Exception e){
			throw new Exception(e.getMessage());
		}
		try{
			this.ps=new PrintStream(new File(this.OutFile),"UTF-8");
		}
		catch(FileNotFoundException e){
			System.out.println(e);
		}
		this.root=this.doc.getDocumentElement();
		this.sentenceNodes=this.root.getElementsByTagName("s");		
	}
	public boolean hasMoreSentence(){
		if(this.sentenceNodes.getLength()<=this.sentenceIndex){
			
			return false;
		}
		else{
			return true;
		}
		
	}
	public void convert() {			
		NodeList wordNodes;
		Node sentenceNode;
		sentenceNode=this.sentenceNodes.item(this.sentenceIndex++);				
		wordNodes=sentenceNode.getChildNodes();
		this.currWordCount=wordNodes.getLength();		
		int i=0;
		for(i=0;i<wordNodes.getLength();++i){
			Node wordNode=wordNodes.item(i);
			if(wordNode instanceof Element){
				Element wordNodeElement=(Element)wordNode;
				Text wordText=(Text)wordNodeElement.getFirstChild();				
				String word=wordText.getData().trim();				
				NamedNodeMap attr=wordNodeElement.getAttributes();			
				Node attrPOS=attr.item(0);				
				String pos=attrPOS.getNodeValue().trim();	
				this.ps.print(word+" "+pos+"\n");
			}
		}			
	}	

	public void ConverterLoop(){
		while(this.hasMoreSentence()){
			this.convert();
			this.ps.print("\n");
		}
	}
	
	
	private Document doc;
	private String FileName;
	private Element root;
	private NodeList sentenceNodes;
	private int sentenceIndex=0;
	private int currWordCount=0; //total number of words present in current sentence
	private PrintStream ps;
	private String OutFile;
	
	public static void main(String args[]){
		XMLToTNTConverter xttc=new XMLToTNTConverter(args[0],args[1]);
		try{
			xttc.init();
			xttc.ConverterLoop();
		}
		catch(Exception e){
			System.out.println("initialization error");
			
		}
	}

}
